> ## Documentation Index
> Fetch the complete documentation index at: https://www.cashfree.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Reverse Geocoding

> Use this API to convert geographic coordinates (latitude and longitude) into readable location information for verification purposes.

View the [test data](https://www.cashfree.com/docs/api-reference/vrs/data-to-test-integration#reverse-geocoding-coordinates) and use the information to trigger the validations.The test data can be used only in the sandbox environment.



## OpenAPI

````yaml post /reverse-geocoding
openapi: 3.0.0
info:
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  contact:
    email: developers@cashfree.com
    name: API Support
    url: https://discord.com/invite/QdZkNSxXsB
  title: Cashfree Verification API's.
  version: '2023-12-18'
  description: >-
    Cashfree's Verification APIs provide different types of verification to our
    merchants.
servers:
  - description: Sandbox Server
    url: https://sandbox.cashfree.com/verification
  - description: Production Server
    url: https://api.cashfree.com/verification
security: []
tags:
  - name: Aadhaar
    description: Operations related to Aadhaar verification.
  - name: BAV V2
    description: Operations related to Bank account verification v2.
  - name: PAN
    description: Operations related to PAN verification.
  - name: Digilocker
    description: Operations related to Digilocker verification.
  - name: E-sign
    description: Operations related to E-sign verification.
  - name: Reverse Penny Drop
    description: Operations related to Reverse Penny Drop verification.
  - name: UPI Penny Drop
    description: Operations related to UPI Penny Drop verification.
  - name: Mobile Penny Drop
    description: Operations related to Mobile Penny Drop verification.
  - name: IP
    description: Operation related to IP verification.
  - name: UPI
    description: Operations related to UPI verification.
  - name: Passport
    description: Operation related to Passport verification.
  - name: CIN
    description: Operation related to CIN verification.
  - name: Name Match
    description: Operation related to Name Match verification.
  - name: PAN to GSTIN
    description: Operation related to PAN to GSTIN.
  - name: Face Match
    description: Operation related to Face Match verification.
  - name: Voter ID
    description: Operation related to Voter ID verification.
  - name: Reverse Geocoding
    description: Operation related to Reverse Geocoding.
  - name: Vehicle RC
    description: Operation related to Vehicle RC verification.
  - name: Driving License
    description: Operation related to Driving License verification.
  - name: GSTIN
    description: Operation related to GSTIN verification.
  - name: Account Aggregator
    description: Operations related to Account aggregator.
  - name: OTPLess
    description: Operations related to OTPLess Verification.
  - name: 1-Click
    description: Operations related to 1-Click.
  - name: Smart OCR
    description: Operations related to Smart OCR.
  - name: Geocoding
    description: Operations related to Geocoding.
  - name: Udyam
    description: Operation related to Udyam verification.
  - name: PAN to Udyam
    description: Operation related to PAN to Udyam.
paths:
  /reverse-geocoding:
    post:
      tags:
        - Reverse Geocoding
      summary: Reverse Geocoding
      description: >-
        Use this API to convert geographic coordinates (latitude and longitude)
        into readable location information for verification purposes.


        View the [test
        data](https://www.cashfree.com/docs/api-reference/vrs/data-to-test-integration#reverse-geocoding-coordinates)
        and use the information to trigger the validations.The test data can be
        used only in the sandbox environment.
      operationId: VrsReverseGeocodingVerification
      parameters:
        - $ref: '#/components/parameters/x_cf_signature'
      requestBody:
        $ref: '#/components/requestBodies/ReverseGeocodingRequest'
      responses:
        '200':
          $ref: '#/components/responses/ReverseGeocodingSuccessResponse'
        '400':
          $ref: '#/components/responses/Response400ReverseGeocoding'
        '401':
          $ref: '#/components/responses/Response401'
        '403':
          $ref: '#/components/responses/Response403'
        '409':
          $ref: '#/components/responses/Response409DuplicateId'
        '422':
          $ref: '#/components/responses/Response422'
        '429':
          $ref: '#/components/responses/Response429'
        '500':
          $ref: '#/components/responses/Response500V2'
        '502':
          $ref: '#/components/responses/Response502V2'
      security:
        - XClientID: []
          XClientSecret: []
components:
  parameters:
    x_cf_signature:
      description: >-
        Send the signature if two-factor authentication is selected as Public
        Key.  [More
        details](https://www.cashfree.com/docs/api-reference/vrs/getting-started#2fa-api-signature-generation).
      name: x-cf-signature
      in: header
      required: false
      schema:
        type: string
      example: ''
  requestBodies:
    ReverseGeocodingRequest:
      description: >-
        Find the request parameters to retrieve the physical address of a
        location.
      required: true
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ReverseGeocodingRequestSchema'
  responses:
    ReverseGeocodingSuccessResponse:
      description: Success response for retrieving physical address of a location.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ReverseGeocodingResponseSchema'
          examples:
            Valid:
              value:
                verification_id: test001
                reference_id: 21637861
                latitude: '12.9274477'
                longitude: '77.6326542'
                address: >-
                  JSS Institutions Campus, First Floor, CA Site No.1, HAL 3rd
                  Stage, HAL 3rd Stage, KodihalliBehind Hotel Leela Palace, HAL
                  2nd Stage, Kodihalli, Bengaluru, Karnataka 560008, India
                city: bangalore
                state: Karnataka
                statecode: KA
                countrycode: In
                pincode: '560008'
                status: VALID
    Response400ReverseGeocoding:
      description: Validation errors for Reverse Geocoding API.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            Invalid Latitude:
              $ref: '#/components/examples/InvalidLatitude'
            Invalid Longitude:
              $ref: '#/components/examples/InvalidLongitude'
            Verification Id Missing:
              $ref: '#/components/examples/VerificationIdMissing'
            Verifcation Id character limit exceeded:
              $ref: '#/components/examples/VerificationIDCharacterLimitExceeded'
            Invalid Verification ID:
              $ref: '#/components/examples/InvalidVerificationId'
            Client ID/Client Secret Missing:
              $ref: '#/components/examples/XClientIdMissing'
            Using-Test-Credentials-in-Prod:
              $ref: '#/components/examples/UsingTestCredentialsInProd'
    Response401:
      description: Invalid client ID and client secret combination.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            Invalid client ID and client secret combination:
              value:
                type: authentication_error
                code: authentication_failed
                message: Invalid clientId and clientSecret combination
    Response403:
      description: Authentication error (IP not whitelisted).
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            IP not whitelisted:
              value:
                type: authentication_error
                code: ip_validation_failed
                message: >-
                  IP not whitelisted your current ip is 106.51.91.104.For IP
                  whitelisting assistance, visit our guide at
                  https://www.cashfree.com/docs/secure-id/get-started/integration/ip-whitelisting-verification
            x-cf-signature header missing:
              value:
                type: validation_error
                code: authentication_failed
                message: x-cf-signature missing in the request header
    Response409DuplicateId:
      description: Conflict error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            Conflict Error:
              value:
                type: validation_error
                code: verification_id_already_exists
                message: verification ID already exists
    Response422:
      description: >-
        Validation error because of insufficient balance to process this
        request.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            Insufficient balance:
              value:
                type: validation_error
                code: insufficient_balance
                message: Insufficient balance to process this request
    Response429:
      description: Rate limit exceed error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            Rate limit error per operation:
              value:
                type: rate_limit_error
                code: too_many_requests_per_operation
                message: Too many requests for this operation, rate limit reached
            Rate limit error per IP:
              value:
                type: rate_limit_error
                code: too_many_requests_per_ip
                message: Too many requests from the IP, rate limit reached
    Response500V2:
      description: Internal error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            Internal Server Error:
              value:
                type: internal_error
                code: verification_failed
                message: something went wrong
    Response502V2:
      description: Gateway error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseSchema'
          examples:
            Bad Gateway:
              value:
                type: internal_error
                code: verification_failed
                message: verification attempt failed
  schemas:
    ReverseGeocodingRequestSchema:
      type: object
      example:
        verification_id: test001
        latitude: '12.9274477'
        longitude: '77.6326542'
      required:
        - verification_id
        - latitude
        - longitude
      properties:
        verification_id:
          description: >-
            It is the unique ID you create to identify the verification request.
            The maximum character limit is 50. Only alphanumeric, period (.),
            hyphen (-), and underscore ( _ ) are allowed.
          type: string
          example: test001
          default: test001
        latitude:
          description: >-
            It is the angular distance expressed in degrees of arc north or
            south of the equator to specify the location.
          type: string
          example: '12.9274477'
          default: '12.9274477'
        longitude:
          description: >-
            It is the angular distance expressed in degrees of arc east or west
            of the equator to specify the location.
          type: string
          example: '77.6326542'
          default: '77.6326542'
    ReverseGeocodingResponseSchema:
      type: object
      example:
        value:
          verification_id: test001
          reference_id: 21637861
          latitude: '12.9274477'
          longitude: '77.6326542'
          address: >-
            JSS Institutions Campus, First Floor, CA Site No.1, HAL 3rd Stage,
            HAL 3rd Stage, KodihalliBehind Hotel Leela Palace, HAL 2nd Stage,
            Kodihalli, Bengaluru, Karnataka 560008, India
          city: bangalore
          state: Karnataka
          statecode: KA
          countrycode: In
          pincode: '560008'
          status: VALID
      properties:
        reference_id:
          description: >-
            It displays the unique ID created by Cashfree Payments for reference
            purposes.

            format: `int64`
          type: integer
          example: 21637861
        verification_id:
          type: string
          description: >-
            It displays the unique ID you created to identify the verification
            request.
          example: test001
        latitude:
          type: string
          description: >-
            It displays the entered angular distance expressed in degrees of arc
            north or south of the equator to specify the location.
          example: '12.9274477'
        longitude:
          type: string
          description: >-
            It displays the entered angular distance expressed in degrees of arc
            east or west of the equator to specify the location.
          example: '77.6326542'
        address:
          type: string
          description: It displays the physical address of the entered coordinates.
          example: >-
            JSS Institutions Campus, First Floor, CA Site No.1, HAL 3rd Stage,
            HAL 3rd Stage, KodihalliBehind Hotel Leela Palace, HAL 2nd Stage,
            Kodihalli, Bengaluru, Karnataka 560008, India
        city:
          type: string
          description: It displays the name of the city of the entered coordinates.
          example: bangalore
        state:
          type: string
          description: It displays the name of the state of the entered coordinates.
          example: Karnataka
        statecode:
          type: string
          description: It displays the state's code of the entered coordinates.
          example: KA
        countrycode:
          type: string
          description: It displays the country's code of the entered coordinates.
          example: In
        pincode:
          type: string
          description: It displays the PIN code information of the entered coordinates.
          example: '560008'
        status:
          type: string
          description: |-
            It displays the status of the entered coordinates.
            Possible values are:
            - `VALID`
          example: VALID
    ErrorResponseSchema:
      type: object
      properties:
        code:
          type: string
          example: x-client-id_missing
        error:
          type: object
          example:
            ref_id: 102
        message:
          type: string
          example: x-client-id is missing in the request.
          description: It displays the outcome of the error.
        type:
          type: string
          example: validation_error
          description: It displays the type of error.
  examples:
    InvalidLatitude:
      value:
        type: validation_error
        code: latitude_value_invalid
        message: latitude value should range from -90 to 90
    InvalidLongitude:
      value:
        type: validation_error
        code: longitude_value_invalid
        message: longitude value should range from -180 to 180
    VerificationIdMissing:
      value:
        type: validation_error
        code: verification_id_missing
        message: verification_id is missing in the request.
    VerificationIDCharacterLimitExceeded:
      value:
        type: validation_error
        code: verification_id_length_exceeded
        message: verification_id can include a maximum of 50 characters.
    InvalidVerificationId:
      value:
        type: validation_error
        code: verification_id_value_invalid
        message: verification_id can include only alphanum, dot, hyphen and underscores
    XClientIdMissing:
      value:
        type: validation_error
        code: x-client-id_missing
        message: x-client-id is missing in the request.
    UsingTestCredentialsInProd:
      value:
        type: validation_error
        code: x-client-secret_value_invalid
        message: Client secret belongs to test environment
  securitySchemes:
    XClientID:
      type: apiKey
      in: header
      name: x-client-id
      description: >-
        Your unique client identifier issued by Cashfree. You can find this in
        your [Merchant
        Dashboard](https://merchant.cashfree.com/verificationsuite/developers/api-keys).
    XClientSecret:
      type: apiKey
      in: header
      name: x-client-secret
      description: >-
        The secret key associated with your client ID. Use this to authenticate
        your API requests. You can find this in your [Merchant
        Dashboard](https://merchant.cashfree.com/verificationsuite/developers/api-keys).

````